SystemOrganization addCategory: #'Spec-Tools-Senders'!
SystemOrganization addCategory: #'Spec-Tools-ChangeSorter'!

Object subclass: #AbstractMessageConverter
	instanceVariableNames: 'message shouldShout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!AbstractMessageConverter commentStamp: '<historical>' prior: 0!
An AbstractMessageConverter is a wrapper used to switch which information to retrieve from a method.

This way, you can avoid switch case, you just have to use set the correct filter!

!AbstractMessageConverter class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/10/2012 12:27'!
message: aMessage

	^ self new
		message: aMessage;
		yourself! !

!AbstractMessageConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 09:23'!
getText

	message ifNil: [ ^ '' ].
	^ self internalGetText! !

!AbstractMessageConverter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 09:17'!
initialize
	"Initialization code for AbstractMessageConverter"

	super initialize.

	message := nil.
	shouldShout := false.! !

!AbstractMessageConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 09:23'!
internalGetText

	^ self subclassResponsibility! !

!AbstractMessageConverter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 08:53'!
message

	^ message! !

!AbstractMessageConverter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 08:53'!
message: aMessage

	message := aMessage! !

!AbstractMessageConverter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:17'!
shouldShout

	^ shouldShout! !

!AbstractMessageConverter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:17'!
shouldShout: aBoolean

	shouldShout := aBoolean! !

AbstractMessageConverter subclass: #ByteCodeMessageConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!ByteCodeMessageConverter commentStamp: '<historical>' prior: 0!
A ByteCodeMessageConverter is a wrapper wich display the bytecode of the provided message!

!ByteCodeMessageConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 09:23'!
internalGetText

	^ message symbolic asText! !

AbstractMessageConverter subclass: #DecompileMessageConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!DecompileMessageConverter commentStamp: '<historical>' prior: 0!
A DecompileMessageConverter is a wrapper wich display the decompile source code of the provided message!

!DecompileMessageConverter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 09:20'!
initialize
	"Initialization code for DecompileMessageConverter"

	super initialize.
	self shouldShout: true.! !

!DecompileMessageConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 09:23'!
internalGetText

	^ message method decompileWithTemps decompileString asText makeSelectorBoldIn: message methodClass! !

AbstractMessageConverter subclass: #SourceMessageConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!SourceMessageConverter commentStamp: '<historical>' prior: 0!
A SourceMessageConverter is a wrapper wich display the source code of the provided message!

!SourceMessageConverter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 09:20'!
initialize
	"Initialization code for SourceMessageConverter"

	super initialize.
	self shouldShout: true.! !

!SourceMessageConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 09:23'!
internalGetText

	^ message sourceCode! !

AbstractMessageConverter subclass: #TimeStampMessageConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!TimeStampMessageConverter commentStamp: '<historical>' prior: 0!
A TimeStampMessageConverter is a wrapper wich display the timestamp of the provided message!

!TimeStampMessageConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 12:49'!
internalGetText
	| list |
	list := message timeStamp subStrings.
	^ String streamContents:[ :s |
			s << 'Last Modification :' << Character cr.
			s << Character tab << 'date:' << Character tab << (list allButFirst joinUsing: ' ') asTimeStamp << Character cr.
 			s << Character tab << 'by:' << Character tab << Character tab << list first ]! !

ComposableModel subclass: #ChangeSorterApplication
	instanceVariableNames: 'model changesListModel classesListModel methodsListModel textModel prettyPrint showDiff title window prettyButton diffButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterApplication commentStamp: '<historical>' prior: 0!
A ChangeSorterApplication is spec version of the dual sorter!

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/10/2012 15:15'!
internSpec

	^ {#PanelWithSplitters.
			#changeTableLayout.
			#listDirection:. 		#bottomToTop.
			#addMorph:.			self topSpec.
			#addMorph:. 		{	#model. 	#methodsListModel.	#internSpec	}.
			#addMorph:. 		{	#model. 	#textModel.	#internSpec	}.
			#addPaneSplitters.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill								}! !

!ChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 15:25'!
topSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:. 		#rightToLeft.
			#addMorph:. 		{	#model. 	#changesListModel.	#internSpec	}.
			#addMorph:. 		{	#model. 	#classesListModel.	#internSpec	}.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill								}! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:19'!
addPreamble

	self model addPreambleTo: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 21:16'!
browseChangeSet
	"Open a message list browser on methods in the current change set"

	| messages |
	messages := self selectedChangeSet changedMessageList select: [ :each | each isValid].	
	Smalltalk tools  messageList
		openMessageList: messages 
		name: 'Methods in Change Set ', self selectedChangeSet name 
		autoSelect: ''! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:27'!
browseImplementorsOfMessages

	self model browseMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/6/2012 03:03'!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	self selectedClass ifNotNil:
		[:myClass | Smalltalk tools browser fullOnClass: myClass selector: self selectedSelector ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:10'!
browseSendersOfMessages

	self model browseSendersOfMessagesFrom: self selectedSelector! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:35'!
browseVersions
	"Create and schedule a changelist browser on the versions of the 
	selected message."
	
	self selectedClass ifNotNil: [:class |
		self selectedSelector ifNotNil: [:selector || method |
			method := class methodDict 
								at: selector 
								ifAbsent: [ ^ self inform: 'Sorry, only actual methods have retrievable versions.' ].
			self model browseVersionsFrom: method ]]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 10:47'!
changeSetMenu1: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	aMenu 
		title: 'Change Set';
		target: self.
		
	self selectedChangeSet
		ifNotNil:[
			aMenu
				add: 'Make changes go to me (m)'
				action: #setCurrentChangeSet;
				addLine;
				add: 'New change set... (n)'
				action: #newSet ].
	aMenu
		add: 'Find...(f)' 
		action: #findChangeSet.

	self selectedChangeSet
		ifNotNil:[
			aMenu
				addLine;
				add: 'Rename change set (r)'
				action: #rename;
				add: 'File out (o)'
				action: #fileOut;
				add: 'Browse methods (b)' 
				action: #browseChangeSet;
				add: 'Browse change set (B)'
				action: #openChangeSetBrowser;
				addLine ]! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 10:50'!
changeSetMenu2: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	| cs |
	
	cs := self selectedChangeSet.
	self selectedChangeSet
		ifNotNil:[
			(cs notNil and: [ cs hasPreamble ])
				ifTrue: [
							aMenu add: 'Edit preamble (p)' action: #addPreamble.
							aMenu add: 'Remove preamble' action: #removePreamble	]
				ifFalse: [	aMenu add: 'Add preamble (p)' action: #addPreamble			].
			(cs notNil and: [ cs hasPostscript ])
				ifTrue: [	
							aMenu add: 'Edit postscript...' action: #editPostscript.
							aMenu add: 'Remove postscript' action: #removePostscript	]
				ifFalse: [	aMenu add: 'Add postscript...' action: #editPostscript			].

			aMenu addLine.

			aMenu add: 'Destroy change set (x)' action: #remove ].! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/4/2012 22:15'!
changeSetMenu: aMenu shifted: isShifted 
	"Set up aMenu to hold commands for the change-set-list pane.  This could be for a single or double changeSorter"
	
	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	self changeSetMenu1: aMenu shifted: isShifted.
	self changeSetMenu2: aMenu shifted: isShifted.
	
	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:23'!
changeSetShortcuts: event from: aMorph

	self selectedChangeSet
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseChangeSet ].
			event keyString = '<Cmd-B>' 		ifTrue: [ ^ self openChangeSetBrowser ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self setCurrentChangeSet ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self newSet ].
			event keyString = '<Cmd-o>' 		ifTrue: [ ^ self fileOut ].
			event keyString = '<Cmd-r>' 		ifTrue: [ ^ self rename ].
			event keyString = '<Cmd-p>' 		ifTrue: [ ^ self addPreamble ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self remove ]].
			
	event keyString = '<Cmd-f>' 				ifTrue: [ ^ self findChangeSet ].
		! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 20:03'!
changeSets

	^ self changesListModel getList! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:25'!
changesListModel

	^ changesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/6/2012 03:25'!
changesMenu: aBlock

	changesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 11:27'!
changesShortcuts: aBlock

	changesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 11:30'!
classMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	self selectedClass ifNil: [ ^ nil ].
	aMenu title: 'Class list'.

	aMenu target: self.
	aMenu addList: #(
			-
			('Delete class from change set (d)'		forgetClass)
			('Remove class from system (x)'		removeClass)
			-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutClass)).

	^ aMenu! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:31'!
classShortcuts: event from: aMorph

	self selectedClass
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetClass ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeClass ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:26'!
classesListModel

	^ classesListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/6/2012 03:25'!
classesMenu: aBlock

	classesListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 11:29'!
classesShortcuts: aBlock

	classesListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:08'!
currentText

	 ^ textModel getText! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 16:46'!
defaultTitle
	
	^  'Change Sorter'! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:23'!
editPostscript
	
	self selectedChangeSet editPostscript! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:09'!
fileOut

	self selectedChangeSet fileOut! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:11'!
fileOutClass

	self model fileOutClass: self selectedClass from: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:09'!
fileOutMessage
	"Put a description of the selected message on a file"

	self selectedSelector ifNotNil: [:selector |
		Cursor write showWhile:
			[ self model fileOutSelector: selector from: self selectedClass ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:00'!
findChangeSet

	| set |
	set := self model findChangeSetIn: self changeSets.
	changesListModel setSelectedItem: set.! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/5/2012 16:59'!
forceChangesListRefresh
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/5/2012 22:56'!
forgetClass
	"Remove all mention of this class from the changeSet"

	self okToChange ifFalse: [^ self].
	self selectedClass ifNotNil: [:class |
		self model removeClass: class from: self selectedChangeSet.
		self setSelectedChangeSet: self selectedChangeSet ].
! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 10:08'!
forgetMessage

	self okToChange ifFalse: [^ self].
	self selectedSelector ifNotNil: [:selector | 
		self model 
			forgetSelector: selector 
			inClass: self selectedClass 
			fromChangeSet: self selectedChangeSet.
		self updateClassesList.
		self setSelectedClassIndex: self selectedClassIndex ]! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:38'!
initialize
	"Initialization code for ChangeSorterApplication"

	super initialize.

	self instantiateWidgets.
	self setFocus.
	
	prettyPrint := false.
	showDiff := false.
	
	model := ChangeSorterModel new.
	title := self defaultTitle.
	
	changesListModel wrappingBlock: [:item | item name ].
	changesListModel items: self model allChanges.
	
	self registerChangeActions.
	self registerClassActions.
	self registerSelectorActions.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:36'!
instantiateChangeSetModel
	
	changesListModel := self instantiate: ListComposableModel.
	changesListModel menu: [:aMenu :shifted | self changeSetMenu: aMenu shifted: shifted  ].
	changesListModel shortcuts: [:event :source | self changeSetShortcuts: event from: source ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:36'!
instantiateClassModel
	
	classesListModel := self instantiate: ListComposableModel.
	classesListModel menu: [:aMenu :shifted | self classMenu: aMenu shifted: shifted ].
	classesListModel shortcuts: [:event :source | self classShortcuts: event from: source ].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:37'!
instantiateMethodModel

	methodsListModel := self instantiate: ListComposableModel.
	methodsListModel menu: [:menu :shifted | self messageMenu: menu shifted: shifted ].
	methodsListModel shortcuts: [:event :source | self methodShortcuts: event from: source ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:50'!
instantiateRadioButtons

	prettyButton := self instantiate: CheckBoxModel.
	diffButton := self instantiate: CheckBoxModel.
	
	prettyButton activationAction: [ 
		prettyPrint := true.
		self updateTextContents ].
	prettyButton desactivationAction: [ 
		prettyPrint := false.
		self updateTextContents  ].
	diffButton activationAction: [ 
		showDiff := true.
		self updateTextContents ].
	diffButton desactivationAction: [ 
		showDiff := false.
		self updateTextContents  ].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 17:19'!
instantiateTextModel

	textModel := self instantiate: TextModel.
	textModel aboutToStyle: true.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:45'!
instantiateWidgets
	
	self instantiateChangeSetModel.
	self instantiateClassModel.
	self instantiateMethodModel.
	self instantiateTextModel.
	
	self instantiateRadioButtons! !

!ChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 11:30'!
messageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	self selectedSelector ifNil: [ ^ nil ].	
	aMenu title: 'Message list'.
	aMenu target: self.

	aMenu addList: #(
			('Delete method from changeSet (d)'	forgetMessage)
			('Remove method from system (x)'		removeMessage)
				-
			('Browse full (b)'						browseMethodFull)
			-
			('FileOut'								fileOutMessage)
			-
			('Senders of... (n)'						browseSendersOfMessages)
			('Implementors of... (m)'				browseImplementorsOfMessages)
			('Versions (v)'							browseVersions)).
	^ aMenu
! !

!ChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:34'!
methodShortcuts: event from: aMorph

	self selectedSelector
		ifNotNil:[
			event keyString = '<Cmd-b>' 		ifTrue: [ ^ self browseMethodFull ].
			event keyString = '<Cmd-d>' 		ifTrue: [ ^ self forgetMessage ].
			event keyString = '<Cmd-m>' 	ifTrue: [ ^ self browseImplementorsOfMessages ].
			event keyString = '<Cmd-n>' 		ifTrue: [ ^ self browseSendersOfMessages ].
			event keyString = '<Cmd-v>' 		ifTrue: [ ^ self browseVersions ].
			event keyString = '<Cmd-x>' 		ifTrue: [ ^ self removeMessage ]].! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:26'!
methodsListModel

	^ methodsListModel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:39'!
methodsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 11:29'!
methodsShortcuts: aBlock

	methodsListModel shortcuts: aBlock! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 16:10'!
model

	^ model! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
newSet

	| aSet |
	self okToChange ifFalse: [ ^ self ].
	aSet := self model createNewSet.
	aSet ifNotNil:
		[	self updateChangesList.
			changesListModel setSelectedItem: aSet ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 10:45'!
openChangeSetBrowser
	| cs env |
	
	cs := self selectedChangeSet.
	cs ifNil: [ ^ nil ].
	
	env := RBBrowserEnvironment new forClasses: cs changedClasses.

	Smalltalk tools browser fullOnEnvironment: env! !

!ChangeSorterApplication methodsFor: 'display' stamp: 'BenjaminVanRyseghem 2/4/2012 16:13'!
openWithSpec

	window := super openWithSpec.
	^ window! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 16:46'!
registerChangeActions
	
	changesListModel
		whenSelectedItemChanges: [:change | 
			classesListModel resetSelection.
			self updateTextContents.
			change 
				ifNil: [
					classesListModel items: {}.
					methodsListModel items: {}.
					self title: self defaultTitle ]
				ifNotNil: [
					classesListModel items: (change changedClasses sort: [:a :b | a name < b name ]).
					self title: change name ]].
	! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 09:56'!
registerClassActions
	
	classesListModel whenSelectedItemChanges: [:class | 
		methodsListModel resetSelection.
		self updateTextContents.
		textModel behavior: class.
		textModel aboutToStyle: false.
		class 
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [ methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort ]].! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:19'!
registerSelectorActions

	methodsListModel whenSelectedItemChanges: [:selector |
		self updateTextContents ]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
remove
	"Completely destroy my change set.  Check if it's OK first"

	self okToChange ifFalse: [^ self].
	self model removeChangeSet: self selectedChangeSet prompting: true.
	self updateChangesList.
	changesListModel resetSelection! !

!ChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/5/2012 23:04'!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	(self model removeClass: self selectedClass)
		ifTrue: [ self setSelectedChangeSet: self selectedChangeSet ]! !

!ChangeSorterApplication methodsFor: 'menu - message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:12'!
removeMessage
	"Remove the selected message from the system."
	
	self okToChange
		ifFalse: [^ self].
	self selectedSelector
		ifNotNil: [:selector |
				(self model removeMethod: selector inClass: self selectedClass)
					ifTrue: [ self updateMessagesList ]]! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:29'!
removePostscript

	self model removePostscriptFrom: self selectedChangeSet.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:25'!
removePreamble

	self selectedChangeSet removePreamble.
	changesListModel setSelectedItem: self selectedChangeSet! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 21:11'!
rename

	| set |
	set := self model rename: self selectedChangeSet.
	
	changesListModel 
		updateList;
		setSelectedItem: set! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:07'!
selectedChangeSet

	 ^ changesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 21:58'!
selectedChangeSetIndex

	 ^ changesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:07'!
selectedClass

	 ^ classesListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 10:07'!
selectedClassIndex

	 ^ classesListModel selectedIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/4/2012 16:44'!
selectedSelector

	 ^ methodsListModel selectedItem! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/6/2012 03:25'!
selectorsMenu: aBlock

	methodsListModel menu: aBlock! !

!ChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:01'!
setCurrentChangeSet

	self model setCurrentChangeSet: self selectedChangeSet.! !

!ChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 16:59'!
setFocus

	self focusOrder
		add: changesListModel;
		add: classesListModel;
		add: methodsListModel;
		add: textModel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 22:20'!
setSelectedChangeSet: aChangeSet

	 ^ changesListModel setSelectedItem: aChangeSet! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 22:02'!
setSelectedChangeSetIndex: anIndex

	 ^ changesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 08:51'!
setSelectedClass: aClass

	 ^ classesListModel setSelectedItem: aClass! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 10:07'!
setSelectedClassIndex: anIndex

	 ^ classesListModel setSelectedIndex: anIndex! !

!ChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 15:26'!
textModel

	^ textModel! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/4/2012 16:11'!
title

	^ title! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 16:56'!
title: aTitle

	title := aTitle.
	window ifNotNil: [ window title: aTitle ]! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
updateChangesList
	| sel |
	
	sel := self selectedChangeSet.
	changesListModel items: self model allChanges.
	changesListModel setSelectedItem: sel.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/5/2012 18:20'!
updateClassesList
	| sel |
	sel := self selectedClass.
	
	self selectedChangeSet
			ifNil: [ classesListModel items: {} ]
			ifNotNil: [:change |	classesListModel items: (change changedClasses sort: [:a :b | a name < b name ])].
				
	classesListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:55'!
updateClassesListAndMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self updateClassesList.
	methodsListModel setSelectedItem: sel.
	self updateMessagesList.! !

!ChangeSorterApplication methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/7/2012 09:56'!
updateMessagesList
	| sel |
	sel := methodsListModel selectedItem.
	
	self selectedClass
			ifNil: [ methodsListModel items: {} ]
			ifNotNil: [:class | methodsListModel items: (self selectedChangeSet selectorsInClass: class name) sort].
				
	methodsListModel setSelectedItem: sel! !

!ChangeSorterApplication methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/7/2012 11:18'!
updateTextContents

	| text |
	text :=  (self model 
				setContentsOfChangeSet: self selectedChangeSet
				forClass: self selectedClass
				andSelector: self selectedSelector
				prettyPrint: prettyPrint
				showDiff: showDiff).
	({'Method was added, but cannot be found!!'. 'Added then removed (see versions)'. 'Method has been removed (see versions)'} includes: text)
		ifTrue: [ textModel aboutToStyle: false ]
		ifFalse: [ textModel aboutToStyle: true ] .
	textModel text: text.! !

!ChangeSorterApplication methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/5/2012 16:03'!
whenChangesListChanges: aBlock

	changesListModel whenListChanges: aBlock! !

ComposableModel subclass: #DualChangeSorterApplication
	instanceVariableNames: 'model changeSorterLeft changeSorterRight isRefreshing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!DualChangeSorterApplication commentStamp: '<historical>' prior: 0!
A DualChangeSorterApplication is a dual change sorter based on psec!

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/10/2012 15:42'!
internSpec

	^ {#PanelWithSplitters.
			#changeTableLayout.
			#listDirection:.	#rightToLeft.
			#addMorph:.	{	#model.	#changeSorterLeft.			#internSpec	}.
			#addMorph:.	{	#model.	#changeSorterRight.		#internSpec	}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#spaceFill.}! !

!DualChangeSorterApplication class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 19:27'!
title

	^'Dual Change Sorter'! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2012 16:08'!
changeSorterLeft

	^ changeSorterLeft! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2012 16:07'!
changeSorterRight

	^ changeSorterRight! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:09'!
checkThatSidesDiffer: escapeBlock
	"If the change sets on both sides of the dual sorter are the same, put up an error message and escape via escapeBlock, else proceed happily"

	changeSorterLeft selectedChangeSet == changeSorterRight selectedChangeSet
		ifTrue:
			[self inform: 
'This command requires that the
change sets selected on the two
sides of the change sorter *not*
be the same.'.
			^ escapeBlock value]
! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:50'!
copyAllToLeft

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (changeSorterRight selectedChangeSet) to: (changeSorterLeft selectedChangeSet).
	changeSorterLeft updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:49'!
copyAllToRight

	self checkThatSidesDiffer: [ ^ self ].
	self model copyAllChangesFrom: (changeSorterLeft selectedChangeSet) to: (changeSorterRight selectedChangeSet).
	changeSorterRight updateClassesList.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:44'!
copyClassToLeft
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	changeSorterRight selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := changeSorterLeft selectedChangeSet.
	
	self model copyClass: changeSorterRight selectedClass from: changeSorterRight selectedChangeSet to: otherChangeSet.
	
	changeSorterLeft setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:43'!
copyClassToRight
	"Place these changes in the other changeSet also"

	| otherChangeSet |
	self checkThatSidesDiffer: [ ^ self ].
	self okToChange ifFalse: [ ^ Beeper beep ].
	changeSorterLeft selectedClass ifNil: [ ^ Beeper beep ].
	otherChangeSet := changeSorterRight selectedChangeSet.
	
	self model copyClass: changeSorterLeft selectedClass from: changeSorterLeft selectedChangeSet to: otherChangeSet.
	
	changeSorterRight setSelectedChangeSet: otherChangeSet.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 10:00'!
copyMethodToLeft
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := changeSorterLeft selectedChangeSet.
	
	changeSorterRight selectedSelector ifNotNil: [:selector || class |
		class := changeSorterRight selectedClass.
		
		self model 
			copySelector: selector 
			inClass: class 
			from: changeSorterRight selectedChangeSet 
			to: other.
			
		changeSorterLeft updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 09:59'!
copyMethodToRight
	"Place this change in the other changeSet also"	
	| other |
	
	self checkThatSidesDiffer: [^ self].
	other := changeSorterRight selectedChangeSet.
	
	changeSorterLeft selectedSelector ifNotNil: [:selector || class |
		class := changeSorterLeft selectedClass.

		self model 
			copySelector: selector 
			inClass: class 
			from: changeSorterLeft selectedChangeSet 
			to: other.		
			
		changeSorterRight updateClassesListAndMessagesList ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:27'!
initialize
	"Initialization code for DualChangeSorterApplication"

	super initialize.

	changeSorterLeft := self instantiate: ChangeSorterApplication.
	changeSorterRight := self instantiate: ChangeSorterApplication.
	model := ChangeSorterModel new.
	isRefreshing := false.
	
	changeSorterLeft 	whenChangesListChanges: [ self leftChangeSetRefreshed 	].
	changeSorterRight	whenChangesListChanges: [ self rightChangeSetRefreshed	].
			
	self menusRegistration.
	self shortcutsRegistration.
	self setFocusOrder! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
leftChangeSetRefreshed

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSorterRight updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:28'!
leftChangeSetShortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllToRight ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractRight ].
	
	^ changeSorterLeft changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:45'!
leftChangesMenu: menu shifted: shifted

	changeSorterLeft changeSetMenu1: menu shifted: shifted.
	
	changeSorterLeft selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to right change set (c)' 
				target: self
				action: #copyAllToRight.
			menu 
				add: 'Submerge into right change set' 
				target: self
				action: #submergeIntoRight.
			menu 
				add: 'Subtract right change set (-)'
				target: self
				action: #subtractRight.
			menu addLine] .
	
	changeSorterLeft changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:43'!
leftClassMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	changeSorterLeft selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu addList: #(
			('Copy class to right change set'			copyClassToRight)	
			('Move class to right change set'			moveClassToRight)
			-
			).
						
	changeSorterLeft classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 09:38'!
leftMenusRegistration.
	
	changeSorterLeft changesMenu: [:menu :shifted | self leftChangesMenu: menu shifted: shifted ].
	changeSorterLeft classesMenu: [:menu :shifted | self leftClassMenu: menu shifted: shifted ].
	changeSorterLeft methodsMenu: [:menu :shifted | self leftMessageMenu: menu shifted: shifted ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:43'!
leftMessageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	changeSorterLeft selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu addList: #(
		('Copy method to  right change set'			copyMethodToRight)
		('Move method to  right change set'			moveMethodToRight)
		-
		).
					
	changeSorterLeft messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:32'!
leftShortcutsRegistration.
	
	changeSorterLeft changesShortcuts: [:event :source | self leftChangeSetShortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/6/2012 03:29'!
menusRegistration

	self leftMenusRegistration.
	self rightMenusRegistration.! !

!DualChangeSorterApplication methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/5/2012 18:47'!
model

	^ model! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/7/2012 08:42'!
moveClassToLeft

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ changeSorterRight selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassToLeft.
	changeSorterRight forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - class' stamp: 'BenjaminVanRyseghem 2/7/2012 08:42'!
moveClassToRight

	self checkThatSidesDiffer: [^ self].
	(self okToChange and: [ changeSorterLeft selectedClass notNil])
		ifFalse: [ ^ false ].

	self copyClassToRight.
	changeSorterLeft forgetClass! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 10:04'!
moveMethodToLeft

	self copyMethodToLeft.
	changeSorterRight forgetMessage.
	changeSorterRight updateClassesListAndMessagesList.! !

!DualChangeSorterApplication methodsFor: 'menu - method' stamp: 'BenjaminVanRyseghem 2/7/2012 10:06'!
moveMethodToRight

	self copyMethodToRight.
	changeSorterLeft forgetMessage.! !

!DualChangeSorterApplication methodsFor: 'event' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
rightChangeSetRefreshed

	isRefreshing
		ifFalse: [
			isRefreshing := true.
			changeSorterLeft updateChangesList.
			isRefreshing := false ]! !

!DualChangeSorterApplication methodsFor: 'shortcuts' stamp: 'BenjaminVanRyseghem 2/7/2012 11:29'!
rightChangeSetShortcuts: event from: aMorph

	event keyString = '<Cmd-c>' 	ifTrue: [ self copyAllToLeft ].
	event keyString = '<Cmd-->' 	ifTrue: [ self subtractLeft ].
	
	^ changeSorterRight changeSetShortcuts: event from: aMorph.! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:45'!
rightChangesMenu: menu shifted: shifted

	changeSorterRight changeSetMenu1: menu shifted: shifted.
	
	changeSorterRight selectedChangeSet
		ifNotNil:[
			menu 
				add: 'Copy all to left change set(c)' 
				target: self
				action: #copyAllToLeft.
			menu 
				add: 'Submerge into left change set' 
				target: self
				action: #submergeIntoLeft.
			menu 
				add: 'Subtract left change set (-)'
				target: self
				action: #subtractLeft.
			menu addLine] .
	
	changeSorterRight changeSetMenu2: menu shifted: shifted.
	^ menu! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:42'!
rightClassMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the class list"

	changeSorterRight selectedClass ifNil: [ ^ nil ].
	aMenu target: self.
	aMenu addList: #(
			('Copy class to left change set'			copyClassToLeft)	
			('Move class to left change set'			moveClassToLeft)
			-
			).
						
	changeSorterRight classMenu: aMenu shifted: shifted.
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 09:39'!
rightMenusRegistration
	
	changeSorterRight changesMenu: [:menu :shifted | self rightChangesMenu: menu shifted: shifted ].
	changeSorterRight classesMenu: [:menu :shifted | self rightClassMenu: menu shifted: shifted ].
	changeSorterRight methodsMenu: [:menu :shifted | self rightMessageMenu: menu shifted: shifted ].! !

!DualChangeSorterApplication methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 2/7/2012 09:42'!
rightMessageMenu: aMenu shifted: shifted
	"Fill aMenu with items appropriate for the message list; could be for a single or double changeSorter"

	changeSorterRight selectedSelector ifNil: [ ^ nil ].	
	aMenu target: self.

	aMenu addList: #(
		('Copy method to left change set'			copyMethodToLeft)
		('Move method to left change set'			moveMethodToLeft)
		-
		).
					
	changeSorterRight messageMenu: aMenu shifted: shifted.
	
	^ aMenu! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:32'!
rightShortcutsRegistration.
	
	changeSorterRight changesShortcuts: [:event :source | self rightChangeSetShortcuts: event from: source ].! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 10:57'!
setFocusOrder

	self focusOrder
		add: changeSorterLeft;
		add: changeSorterRight.! !

!DualChangeSorterApplication methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/7/2012 11:28'!
shortcutsRegistration

	self leftShortcutsRegistration! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
submergeIntoLeft
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| rightChangeSet other index |

	rightChangeSet := changeSorterRight selectedChangeSet.
	other := changeSorterLeft selectedChangeSet.
	index := changeSorterRight selectedChangeSetIndex.

	(self model submerge: rightChangeSet into: other) ifFalse: [ ^ self ].
	
	changeSorterRight updateChangesList.
	changeSorterRight setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/7/2012 09:03'!
submergeIntoRight
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	| leftChangeSet other index |

	leftChangeSet := changeSorterLeft selectedChangeSet.
	other := changeSorterRight selectedChangeSet.
	index := changeSorterLeft selectedChangeSetIndex.

	(self model submerge: leftChangeSet into: other) ifFalse: [ ^ self ].
	
	changeSorterLeft updateChangesList.
	changeSorterLeft setSelectedChangeSetIndex: index.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:24'!
subtractLeft
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := changeSorterRight selectedChangeSet.
	destination := changeSorterLeft selectedChangeSet.
	
	self checkThatSidesDiffer: [^ self].
	
	self model substractFrom: source to: destination.
	
	changeSorterRight setSelectedChangeSet: source.! !

!DualChangeSorterApplication methodsFor: 'menu - change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:23'!
subtractRight
	"Subtract the changes found on the other side from the requesting side."
	| source destination |
	source := changeSorterLeft selectedChangeSet.
	destination := changeSorterRight selectedChangeSet.

	self checkThatSidesDiffer: [^ self].

	self model substractFrom: source to: destination.

	changeSorterLeft setSelectedChangeSet: source.! !

ComposableModel subclass: #MessageBrowser
	instanceVariableNames: 'listModel textConverter textModel toolbarModel maxClassSize window refreshingBlockHolder cachedHierarchy wrapper searchedStringHolder titleHolder model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!MessageBrowser commentStamp: '<historical>' prior: 0!
A MessageBrowser is a UI to browse a list of method, regardless of what they could be.


I could use a MultiColumnList but since I know the width directly, it simplier this way!

!MessageBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/22/2012 19:12'!
browseImplementors: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForImplementorsOf: aSymbol;
		messages: aCollection;
		title: aName;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/19/2012 18:27'!
browseMessages: aCollection refreshingBlock: aBlock named: anObject

	^ self new
		refreshingBlock: aBlock;
		messages: aCollection;
		yourself! !

!MessageBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/22/2012 18:55'!
browseSenders: aCollection of: aSymbol named: aName

	^ self new
		setRefreshingBlockForSendersOf: aSymbol;
		messages: aCollection;
		title: aName;
		autoSelect: aSymbol;
		yourself! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/12/2012 14:29'!
internSpec
	| delta |
	delta := 13.
	^{ #PanelWithSplitters.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #listModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 1@0.5).	(0@0 corner: 0@(delta negated)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #toolbarModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@0.5).	(0@(delta negated) corner: 0@delta). }}.															
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #textModel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0.5 corner: 1@1).	(0@delta corner: 0@0). }}.
			#addPaneSplitters.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!MessageBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/19/2012 18:26'!
on: aList named: aString autoSelect: aSelector

	^ self new
		messages: aList;
		title: aString;
		autoSelect: aSelector;
		yourself! !

!MessageBrowser class methodsFor: 'tool registration' stamp: 'BenjaminVanRyseghem 2/19/2012 18:43'!
openMessageList: messageList name: aString autoSelect: aSelector
	" Tool registry compitibility "

	| title |
	aString last = $]
			ifTrue: [ title := aString substrings allButLast joinUsing: ' ' ]
			ifFalse: [ title := aString ].
			
	(aString beginsWith: 'Senders')
		ifTrue: [ ^ (self browseSenders: messageList of: aSelector named: title) openWithSpec ].
	
	(aString beginsWith: 'Implementors')
		ifTrue: [ ^ (self browseImplementors: messageList of: aSelector named: title) openWithSpec ].
	
	^ (self on: messageList named: title autoSelect: aSelector) openWithSpec! !

!MessageBrowser class methodsFor: 'tool registration' stamp: 'BenjaminVanRyseghem 2/22/2012 18:24'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	"registry register: self as: #messageList"! !

!MessageBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/10/2012 13:34'!
title

	^ 'Message Browser'! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/11/2012 20:50'!
accept: text notifying: notifyer

	listModel selectedItem
		ifNotNil: [:message | message methodClass compile: text notifying: notifyer ]! !

!MessageBrowser methodsFor: 'text selection' stamp: 'BenjaminVanRyseghem 2/22/2012 19:04'!
autoSelect: aSelector

	textModel readSelectionBlock: [:text | self searchedString: aSelector in: text ]! !

!MessageBrowser methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 2/12/2012 01:26'!
buildHierarchyForMessages: messages
	| result classes |
	
	result := IdentityDictionary new.
	classes := (messages collect: #methodClass) asSet.
	messages do: [:message || level class |
		class := message methodClass.
		level := OrderedCollection new.
		class allSuperclassesDo: [:superClass |
			(classes includes: superClass)
				ifTrue: [ level addFirst: superClass ]].
		level addLast: class.
		level addLast: message selector.
		result at: message put: level ].
	^ result! !

!MessageBrowser methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 2/12/2012 02:02'!
cacheHierarchyForClasses: aCollection

	cachedHierarchy := self buildHierarchyForMessages: aCollection.! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/22/2012 00:09'!
eventRegistration
	
	listModel whenSelectedItemChanges: [:item |
			toolbarModel method: item.
			textModel behavior: (item ifNil: [ nil ] ifNotNil: [ item methodClass ]).
			textModel text: (textConverter message: item; getText)].
		
	listModel whenListChanges: [ self setTitle ].
		
	titleHolder
		whenChangedDo: [ self setTitle ]! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/21/2012 17:13'!
highlightSearchedString: string
	
	| searchedString interval firstIndex |
	searchedString := searchedStringHolder contents.
	searchedString ifNil: [ ^ 0 to: 0 ].

	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := string findString: searchedString.
					interval := firstIndex to: (firstIndex+searchedString size-1)]
				ifFalse: [| lastIndex |
					firstIndex := string findString: list first,':'.
					lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
					interval := firstIndex to: (lastIndex + list last size)]]
		ifFalse: [
			" unary selector "
			firstIndex := string findString: searchedString.
			interval := firstIndex to: (firstIndex+searchedString size-1)].
	^ interval! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/22/2012 00:08'!
initialExtent

	^ (500 min: (World extent x)) @ (550 min: (World extent y))! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 18:59'!
initialize
	"Initialization code for MessageBrowser"

	super initialize.
	listModel := self instantiate: MultiColumnListModel.
	textConverter := SourceMessageConverter new.
	textModel := self instantiate: TextModel.
	textModel aboutToStyle: true.
	toolbarModel := self instantiate: MethodToolbar.
	maxClassSize = nil.
	refreshingBlockHolder := [ :item | false ] asValueHolder.
	searchedStringHolder := '' asValueHolder.
	titleHolder := super title asValueHolder.
	model := AbstractTool new.
	listModel wrappingBlock: [ :item | self wrapItem: item ].
	
	self
		setListMenu;
		setListShortcuts;
		eventRegistration;
		initializeDropList;
		registerToAnnouncements;
		setFocus.
		
	textModel action: [ :text :notifyer | self accept: text notifying: notifyer ].! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 15:57'!
initializeDropList

	| item1 item2 item3 item4 |
	item1 := DropListItem 
					named: 'Source' 
					do: [ self textConverter: SourceMessageConverter new ].
	item2 := DropListItem 
					named: 'Byte Code' 
					do: [ self textConverter: ByteCodeMessageConverter new ].
	item3 := DropListItem
					named: 'Decompile' 
					do: [ self textConverter: DecompileMessageConverter new ].
	item4 := DropListItem
					named: 'Time stamp' 
					do: [ self textConverter: TimeStampMessageConverter new ].
	toolbarModel setDropListItems: {item1. item2. item3. item4}! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:12'!
listModel
	
	^ listModel! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 18:01'!
listShortcutsFor: event form: source message: method

	event keyString = '<Cmd-b>'			ifTrue: [ ^ Smalltalk tools browser fullOnClass: method methodClass selector: method selector ].
	event keyString = '<Cmd-i>'			ifTrue: [ ^ method inspect ].
	event keyString = '<Cmd-x>'			ifTrue: [ ^ model removeMethod: method inClass: method methodClass ].
	event keyString = '<Cmd-n>'			ifTrue: [ ^ model browseSendersOfMessagesFrom: method selector ].
	event keyString = '<Cmd-m>'			ifTrue: [ ^ model browseMessagesFrom: method selector ].
	event keyString = '<Cmd-N>'			ifTrue: [ ^ model browseClassRefsOf: method methodClass ].
	event keyString = '<Cmd-v>'			ifTrue: [ ^ model browseVersionsFrom: method ].
	^ false! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/12/2012 01:11'!
maxClassSize

	^ maxClassSize ifNil:[| elt stm |
			elt := (listModel getList detectMax: [:e | e methodClass name size + (cachedHierarchy at: e) size]).
			stm := String streamContents: [:t | 
				3 to: (cachedHierarchy at: elt) size do: [:i | t << '    '].
				t << elt methodClass name ].
			maxClassSize := StandardFonts listFont widthOfString: stm ].
! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 19:05'!
messages: aCollection

	self cacheHierarchyForClasses: aCollection.
	listModel items: (cachedHierarchy keys sort: [:a :b | self sortClassesInCachedHierarchy: a b: b]) asOrderedCollection.
	listModel listSize > 1
		ifTrue: [ 
			listModel setSelectedIndex: 1 ].! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 2/19/2012 19:02'!
methodAdded: anAnnouncement
	| item |	
		
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].
	[ 	| sel text boolean |
		boolean := textModel hasUnacceptedEdits.
		boolean ifTrue: [ text := textModel pendingText ].
		sel := listModel selectedItem.
		self messages: (listModel getList add: item; yourself).
		listModel setSelectedItem: sel.
		boolean ifTrue: [ textModel pendingText: text ]
	] fork! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 2/19/2012 19:04'!
methodModified: anAnnouncement
	| item oldItem sel |
	
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	oldItem := anAnnouncement oldItem.
	sel := listModel selectedItem.
	sel ifNil: [ ^ self ].
	(sel notNil and: [(sel methodClass = oldItem methodClass and: [ sel selector = oldItem selector ])]) ifFalse: [ ^ self ].
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self) ifFalse: [ ^ self ].	
	[	| text  list edits |
		edits := textModel hasUnacceptedEdits.
		edits
			ifTrue: [ text := textModel pendingText ].
		list := listModel getList 
				remove: sel ifAbsent: [];
				add: item;
				yourself. 
		self messages: list.
		listModel setSelectedItem: item.
		edits
			ifTrue: [ 
				textModel pendingText: text.
				textModel changed: #codeChangedElsewhere ].
		] fork! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 2/11/2012 18:17'!
methodRecategorized: aMethod! !

!MessageBrowser methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 2/22/2012 17:23'!
methodRemoved: anAnnouncement
	| item |
	refreshingBlockHolder ifNil: [ ^ self ].
	item := anAnnouncement item.
	(refreshingBlockHolder contents cull: item cull: anAnnouncement cull: self)
		ifFalse: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	[ 	| sel itm text boolean removed |
		sel := listModel selectedIndex.
		itm := listModel selectedItem.
		text := textModel pendingText.
		boolean := true.
		(itm notNil and: [(itm methodClass = item methodClass and: [ itm selector = item selector ])])
			ifTrue: [ boolean := textModel okToChange ].
		self messages: (listModel getList remove: item ifAbsent: [ nil ]; yourself).
		listModel setSelectedIndex: sel.
		boolean ifTrue: [ textModel pendingText: text ]
	] fork! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/23/2012 19:33'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/22/2012 00:10'!
openWithSpec

	window := super openWithSpec.
	self setTitle.
	textModel text: textModel getText.
	^ window! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 17:07'!
refreshingBlock: aBlock

	refreshingBlockHolder contents: aBlock! !

!MessageBrowser methodsFor: 'announcements-registration' stamp: 'BenjaminVanRyseghem 2/10/2012 17:02'!
registerToAnnouncements

	SystemAnnouncer announcer weak		
		on: MethodAdded send: #methodAdded: to: self;
		on: MethodModified send: #methodModified: to: self;
		on: MethodRecategorized send: #methodRecategorized: to: self;
		on: MethodRemoved send: #methodRemoved: to: self! !

!MessageBrowser methodsFor: 'text selection' stamp: 'BenjaminVanRyseghem 2/23/2012 19:06'!
searchedString: searchedString in: aString
	| string interval firstIndex |
	
	searchedString ifNil: [ ^ 0 to: 0 ].
	aString isEmptyOrNil ifTrue: [ ^0 to: 0 ].
	string := aString asString.
	interval := 0 to: 0.
	
	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: searchedString startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]]
				ifFalse: [| lastIndex |
					firstIndex := 1.
					[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
						whileTrue: [
							firstIndex := string findString: list first,':' startingAt: firstIndex+1.
							firstIndex isZero
								ifFalse: [ 
									lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
									interval := firstIndex to: (lastIndex + list last size)]]]]
		ifFalse: [
			" unary selector "
			firstIndex := 1.
			[ firstIndex isZero not and: [ (string at: (firstIndex +1)) isAlphaNumeric ]]
				whileTrue: [
					firstIndex := string findString: searchedString startingAt: firstIndex +1.
					firstIndex isZero
						ifFalse: [ interval := firstIndex to: (firstIndex+searchedString size-1)]]].
	^ interval! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 17:09'!
selectedMessage

	^ listModel selectedItem! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 17:08'!
selectedMessage: aMessage

	listModel setSelectedItem: aMessage.! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/19/2012 19:05'!
setFocus

	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 18:02'!
setListMenu

	listModel menu: [:menu || message |
		message := self selectedMessage.
		menu
			add: 'Browse full... (b)'
			target: Smalltalk tools browser
			selector: #fullOnClass:selector:
			argumentList: {message methodClass. message selector };
			add: 'Inspect method... (i)'
			target: message
			selector: #inspect;
			addLine;
			add: 'Remove method... (x)'
			target: model
			selector: #removeMethod:inClass:
			argumentList: {message. message methodClass.};
			add: 'Toggle Breakpoint'
			target: model
			selector: #toggleBreakOnEntryIn:
			argument: message;
			addLine;
			add: 'Senders of... (n)'
			target: model
			selector: #browseSendersOfMessagesFrom:
			argument: message selector;
			add: 'Implementors of... (m)'
			target: model
			selector: #browseMessagesFrom:
			argument: message selector ;
			add: 'Users of... (N)'
			target: model
			selector: #browseClassRefsOf:
			argument: message methodClass;
			add: 'Versions... (v)'
			target: model
			selector: #browseVersionsFrom:
			argument: message.
		menu]! !

!MessageBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/21/2012 18:02'!
setListShortcuts

	listModel shortcuts: [:event :source || message |
		message := self selectedMessage.
		self listShortcutsFor: event form: source message: message ]! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/19/2012 17:50'!
setRefreshingBlockForImplementorsOf: aSelector

	self refreshingBlock: [:message | message selector = aSelector ].! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/19/2012 17:50'!
setRefreshingBlockForSendersOf: aSelector
	| specialFlag specialByte |
	
	specialFlag := Smalltalk 
				hasSpecialSelector: aSelector
				ifTrueSetByte: [ :b | specialByte := b ].

	self refreshingBlock: [:method | (method refersToLiteral: aSelector) or: [ specialFlag and: [ method scanFor: specialByte ]]]! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/22/2012 00:09'!
setTitle
		
	window ifNotNil: [ window title: self title , ' [' , listModel listSize printString , ']']! !

!MessageBrowser methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 2/10/2012 17:35'!
sortClassesInCachedHierarchy: a b: b
	"Bullshitty name, Thanks Camillo"
	| index aa bb minSize|
	aa := cachedHierarchy at: a.
	bb := cachedHierarchy at: b.
	
	minSize := aa size min: bb size.
	
	1 to: minSize do: [ :i | |compare|
		compare := (aa at: i) name compare: (bb at: i) name.
		compare ~~ 2
			ifTrue: [  ^ compare == 1 ]].
	^  aa size < bb size! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:12'!
textConverter
	
	^ textConverter! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:21'!
textConverter: aTextConverter

	textConverter := aTextConverter message: textConverter message.
	textModel aboutToStyle: textConverter shouldShout .
	textModel text: textConverter getText.! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:12'!
textModel
	
	^ textModel! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/21/2012 17:15'!
title

	^ titleHolder contents! !

!MessageBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/21/2012 17:15'!
title: aString

	titleHolder contents: aString.! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:12'!
toolbarModel
	
	^ toolbarModel! !

!MessageBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/13/2012 19:43'!
window
	
	^ window! !

!MessageBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/19/2012 18:24'!
wrapItem: anItem
	| s |
	
	s :=String streamContents: [:t | 
		3 to: (cachedHierarchy at: anItem) size do: [:i | t << '    '].
		t << anItem methodClass name ].
	
	^ {s. anItem selector}.! !

ComposableModel subclass: #MethodToolbar
	instanceVariableNames: 'methodHolder browseModel sendersModel implementorsModel versionModel dropListModel model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-Senders'!

!MethodToolbar commentStamp: '<historical>' prior: 0!
A MethodToolbar is xxxxxxxxx.

b := MethodToolbar new.
b openWithSpec.
b method: (ButtonModel>>#state:).
b method: nil!

!MethodToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/10/2012 12:25'!
internSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#browseModel.	#internSpec}.
			#addMorph:. {#model.	#sendersModel.	#internSpec}.
			#addMorph:. {#model.	#implementorsModel.	#internSpec}.
			#addMorph:. {#model.	#versionModel.	#internSpec}.
			#addMorph:. {#model.	#dropListModel.	#internSpec}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!MethodToolbar class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/18/2012 01:04'!
title

	^ 'Toolbar'! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/1/2012 18:26'!
addAll: aWindow  withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@0 corner: 0@30)).! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/18/2012 01:22'!
browseMethod

	methodHolder contents
		ifNotNil: [:aMethod | aMethod browse ]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:37'!
browseModel

	^ browseModel! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 12:26'!
dropListModel

	^ dropListModel! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 13:32'!
implementorsMethod

	methodHolder contents
		ifNotNil: [:aMethod | self model browseMessagesFrom: aMethod selector ]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:37'!
implementorsModel

	^ implementorsModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 13:31'!
initialize
	"Initialization code for MethodToolbar"

	super initialize.

	methodHolder := nil asValueHolder.
	browseModel := self instantiate: ButtonModel.
	sendersModel := self instantiate: ButtonModel.
	implementorsModel := self instantiate: ButtonModel.
	versionModel := self instantiate: ButtonModel.
	dropListModel := self instantiate: DropListModel.
	model := AbstractTool new.

	self setFocusOrder.
	
	self setBrowseModel.
	self setVersionModel.
	self setSendersModel.
	self setImplementorsModel.

	"self registerForChanges."! !

!MethodToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/18/2012 00:35'!
method: aMethod

	methodHolder contents: aMethod! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 13:33'!
model

	^ model! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 12:50'!
registerForChanges

	methodHolder whenChangedDo: [:contents || boolean |
		boolean := contents
						ifNil: [ false ]
						ifNotNil: [ true ].
		browseModel state: boolean.
		sendersModel state: boolean.
		versionModel state: boolean.
		implementorsModel state: boolean]! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 13:32'!
sendersMethod

	methodHolder contents
		ifNotNil: [:aMethod | self model browseSendersOfMessagesFrom: aMethod selector ]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:37'!
sendersModel

	^ sendersModel! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:13'!
setBrowseModel
	
	browseModel
		state: false;
		label: 'Browse';
		action: [ self browseMethod ].
	
! !

!MethodToolbar methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 12:26'!
setDropListItems: aCollection

	dropListModel items: aCollection! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 09:32'!
setFocusOrder

	self focusOrder
		add: browseModel;
		add: sendersModel;
		add: implementorsModel;
		add: versionModel.
		! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/10/2012 09:32'!
setImplementorsModel
	
	implementorsModel
		state: false;
		label: 'Implementors';
		action: [ self implementorsMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:18'!
setSendersModel
	
	sendersModel
		state: false;
		label: 'Senders';
		action: [ self sendersMethod ].
	
! !

!MethodToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/18/2012 01:13'!
setVersionModel
	
	versionModel
		state: false;
		label: 'Version';
		action: [ self versionMethod ].
	
! !

!MethodToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/10/2012 13:33'!
versionMethod

	methodHolder contents
		ifNotNil: [:aMethod | self model browseVersionsFrom: aMethod ]! !

!MethodToolbar methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/10/2012 09:37'!
versionModel

	^ versionModel! !

AbstractTool subclass: #ChangeSorterModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tools-ChangeSorter'!

!ChangeSorterModel commentStamp: '<historical>' prior: 0!
A ChangeSorterModel is a model used by Change Sorter UIs for computation!

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:16'!
addPreambleTo: aChangeSet

	aChangeSet assurePreambleExists! !

!ChangeSorterModel methodsFor: 'environment' stamp: 'BenjaminVanRyseghem 2/4/2012 16:19'!
allChanges

	^ ChangeSet allChangeSets reverse! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:42'!
buildChangeSetDescriptionFor: changeSet
		
	^ changeSet
		ifNil: [ '' ] 
		ifNotNil: [ changeSet preambleString ifNil: ['']]! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:24'!
buildClassDescriptionFor: changeSet class: class
	| stream |

	stream := (String new: 100) writeStream.
		(changeSet classChangeAt: class name)
			do: [:each | 
				each = #remove
					ifTrue: [ stream nextPutAll: 'Entire class was removed.'; cr ].
				each = #addedThenRemoved
					ifTrue: [ stream nextPutAll: 'Class was added then removed.'; cr ].
				each = #rename
					ifTrue: [ stream nextPutAll: 'Class name was changed.'; cr ].
				each = #add
					ifTrue: [ stream nextPutAll: 'Class definition was added.'; cr ].
				each = #change
					ifTrue: [ stream nextPutAll: 'Class definition was changed.'; cr ].
				each = #reorganize
					ifTrue: [ stream nextPutAll: 'Class organization was changed.'; cr ].
				each = #comment 
					ifTrue: [ stream nextPutAll: 'New class comment.'; cr ]].
		^ stream contents! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:02'!
buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff

	| changeType code |
	changeType := changeSet atSelector: selector class: class name.
	
	changeType == #remove
		ifTrue: [^ 'Method has been removed (see versions)'].
	changeType == #addedThenRemoved
		ifTrue: [^ 'Added then removed (see versions)']. 
	class
		ifNil: [^ 'Method was added, but cannot be found!!'].
	(class includesSelector: selector)
		ifFalse: [^ 'Method was added, but cannot be found!!'].
	code := class sourceCodeAt: selector.
	prettyPrint
		ifTrue: [ code := class prettyPrinterClass
							format: code
							in: class
							notifying: nil ].						
	showDiff
		ifTrue: [ code := self diffFromPriorSourceFor: code ].
		
	^ code asText makeSelectorBoldIn: class! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/5/2012 18:13'!
copyAllChangesFrom: source to: destination

	destination assimilateAllChangesFoundIn: source! !

!ChangeSorterModel methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:42'!
copyClass: aClass from: source to: destination

	destination absorbClass: aClass name from: source.! !

!ChangeSorterModel methodsFor: 'message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:59'!
copySelector: selector inClass: class from: source to: destination

	destination
		absorbMethod: selector 
		class: class 
		from:source! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 17:33'!
createNewSet

	^ ChangeSet newChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/6/2012 03:13'!
fileOutClass: aClass from: aChangeSet
	"this is a hack!!!! makes a new change set, called the class name, adds author initials to try to make a unique change set name, files it out and removes it. kfr 16 june 2000"
	"Method copied from ChangeSorter"
	| aSet |
	"File out the selected class set."
     aSet := ChangeSet newChangeSet: aClass name.
	aSet ifNil:[ ^self ].
	aSet absorbClass: aClass name from: aChangeSet.
	aSet fileOut.
	ChangeSet removeChangeSet: aSet.! !

!ChangeSorterModel methodsFor: 'message' stamp: 'BenjaminVanRyseghem 2/7/2012 09:08'!
fileOutSelector: selector from: aClass
	
	aClass fileOutMethod: selector! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:03'!
findChangeSetIn: aCollectionOfChangeSets
	"Search for a changeSet by name.  Pop up a menu of all changeSets whose name contains the string entered by the user.  If only one matches, then the pop-up menu is bypassed"
	| index pattern candidates nameList |
	self okToChange ifFalse: [^ self].
	pattern := UIManager default request: 'ChangeSet name or fragment?'.
	pattern isEmptyOrNil ifTrue: [^ self].
	nameList := aCollectionOfChangeSets collect: #name.
	candidates := aCollectionOfChangeSets select:
			[:c | (nameList includes: c name) and: 
				[c name includesSubstring: pattern caseSensitive: false]].
	candidates size = 0 ifTrue: [ ^ Beeper beep ].
	candidates size = 1 ifTrue: [ ^ candidates first ].
	index := UIManager default chooseFrom: (candidates collect: [:each | each name]).
	index = 0 ifFalse: [ ^ (candidates at: index) ].! !

!ChangeSorterModel methodsFor: 'message' stamp: 'BenjaminVanRyseghem 2/7/2012 08:52'!
forgetSelector: selector inClass: aClass fromChangeSet: aChangeSet

	aChangeSet
			removeSelectorChanges: selector 
			class: aClass! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:32'!
removeChangeSet: aChangeSet prompting: doPrompt
	"Completely destroy my change set.  Check if it's OK first, and if doPrompt is true, get the user to confirm his intentions first."

	| message aName changeSetNumber msg |
	aName := aChangeSet name.
	aChangeSet okayToRemove ifFalse: [^ self]. "forms current changes for some project"
	(aChangeSet isEmpty or: [doPrompt not]) ifFalse:
		[message := 'Are you certain that you want to 
remove (destroy) the change set
named  "', aName, '" ?'.
		(self confirm: message) ifFalse: [^ self]].

	doPrompt ifTrue:
		[msg := aChangeSet hasPreamble
			ifTrue:
				[aChangeSet hasPostscript
					ifTrue:
						['a preamble and a postscript']
					ifFalse:
						['a preamble']]
			ifFalse:
				[aChangeSet hasPostscript
					ifTrue:
						['a postscript']
					ifFalse:
						['']].
		msg isEmpty ifFalse:
			[(self confirm: 
'Caution!!  This change set has
', msg, ' which will be
lost if you destroy the change set.
Do you really want to go ahead with this?') ifFalse: [^ self]]].

	"Go ahead and remove the change set"
	changeSetNumber := aChangeSet name initialIntegerOrNil.
	changeSetNumber ifNotNil: [SystemVersion current unregisterUpdate: changeSetNumber].
	ChangeSet removeChangeSet: aChangeSet.! !

!ChangeSorterModel methodsFor: 'class' stamp: 'BenjaminVanRyseghem 2/5/2012 22:57'!
removeClass: class from: changeSet

	changeSet removeClassChanges: class.! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 22:28'!
removePostscriptFrom: aChange

	(aChange hasPostscript and: [ aChange postscriptHasDependents ]) ifTrue:
		[^ self inform:
'Cannot remove the postscript right
now because there is at least one
window open on that postscript.
Close that window and try again.'].

	aChange removePostscript.! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 20:13'!
rename: aChangeSet
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName := UIManager default request: 'New name for this change set'
						initialAnswer: aChangeSet name.
						
	(newName = aChangeSet name or: [newName isEmptyOrNil]) ifTrue:
			[ ^ Beeper beep ].

	(ChangeSet named: newName) ifNotNil:
			[ ^ UIManager default inform: 'Sorry that name is already used' ].

	aChangeSet name: newName.
	^ aChangeSet! !

!ChangeSorterModel methodsFor: 'text' stamp: 'BenjaminVanRyseghem 2/4/2012 16:03'!
setContentsOfChangeSet: changeSet forClass: class andSelector: selector prettyPrint: prettyPrint showDiff: showDiff 
	"return the source code that shows in the bottom pane"
	| strm changeType code |

	
	class
		ifNil: [
			"Only the change set is currently selected"
			^ self buildChangeSetDescriptionFor: changeSet ].
	selector isNil
		ifTrue: [ 
			"class is selected but not the selector"
			^ self buildClassDescriptionFor: changeSet class: class ]
		ifFalse: [
			"a class and a selector are selected"
			^ self buildSelectorDescriptionFor: changeSet class: class selector: selector prettyPrint: prettyPrint showDiff: showDiff ]! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/4/2012 17:18'!
setCurrentChangeSet: aChangeSet

	ChangeSet newChanges: aChangeSet! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:01'!
submerge: source into: destination
	"Copy the contents of the receiver to the other side, then remove the receiver -- all after checking that all is well."
	|   message |
	source == destination
		ifTrue: [ ^ false ].
	source isEmpty
		ifTrue: [ 
			self inform: 'Nothing to copy.  To remove,
simply choose "remove".'.
			^ false ].

	source okayToRemove ifFalse: [^ false].
	message := 'Please confirm:  copy all changes
in "', source name, '" into "', destination name, '"
and then destroy the change set
named "', source name, '"?'.
 
	(self confirm: message) ifFalse: [^ false].

	(source hasPreamble or: [source hasPostscript]) ifTrue:
		[(self confirm: 
'Caution!!  This change set has a preamble or
a postscript or both.  If you submerge it into
the other side, these will be lost.
Do you really want to go ahead with this?') ifFalse: [^ false]].

	self copyAllChangesFrom: source to: destination.
	self removeChangeSet: source prompting: false.
	^ true! !

!ChangeSorterModel methodsFor: 'change set' stamp: 'BenjaminVanRyseghem 2/5/2012 22:23'!
substractFrom: source to: destination

	source forgetAllChangesFoundIn: destination.! !
